(* AfViews

Ver, 1.00 2020/12/13 TSortListView, TCheckTreeView 𓝍AOLE Drag'nDrop ֘A̋@\ǉB

TListViewAf

Ver, 1.00 2007/11/28 ^B
Ver, 1.01 2012/02/17 XPɕύXB
Ver, 1.02 2020/10/02 RXgN^[, SortByIndex CBColClick BOnDrawArrow ǉB

@\ǉXgr[

WindowsXPȍ~ΉB
SotrType = stNone  JNbNŕră\[gB
ȊOŃ\[gꍇ SortType KXݒ肵ă}jAŃ\[g邱ƁB

vpeB
SortIndex;      \[gJB-1 Ń\[gȂB
SortAscend;     \[gBTrue ŏAFalse ō~B
HoverTracking;  }EXzo[oݒBLȂ OnMouseHover NB
DropTarget;     ~XCHlXVꂽꍇAO DropTarget B

\bh
SetSortArrow;         Jɖ`ʁB
SortByIndex;          wJŃ\[gB
StartHoverTracking;   }EXzo[oJnB
CancelHoverTracking;  }EXzo[o~B
ScrollBy;             J[\iwXN[WjɂXN[B

Cxg
OnDrawArrowG  SetSortArrow Ă΂ꂽɔB
OnBeginDrag;   LVN_BEGINDRAG, LVN_BEGINRDRAG ʒm͂ۂɔB
OnMouseHover:  J[\莞ԓȂƂɔB HoverTracking ~B

̂ق̃vpeBA\bhACxg TListView ƓB

TTreeViewAf

Ver, 1.00 2012/04/25 ꉞB
Ver, 1.01 2012/11/29 ̕ύXB
Ver, 1.02 2015/01/06 GetChkCount CB
Ver, 1.03 2018/01/21 SʓIɍ蒼B
Ver, 1.04 2018/04/11 CNNotify CBClearCheck ǉB

@\ǉc[r[ƃm[hwpNX

`FbNԂ TreeNode ̃wpNXŎB
ۂɂ StateImages Ŋ蓖ĂāA`FbN{bNXȂA`FbNA`FbN̏ɎgpB
Node.StateIndex  *.dfm ɕۑłȂH

TTreeNodeHelper

vpeB
Checked;      `FbN{bNX`FbNĂ邩ǂB
Bold;         m[h𑾎ŕ\邩ǂB
SiblingCount; Z֌Wɂm[h̐B

\bh
GetFirstSibling;  Z֌Wɂŏ̃m[hB
GetLastSibling;   Z֌WɂŌ̃m[hB

̂ق̃\bhAvpeBACxg TTreeNode ƓB

TTreeViewAf

vpeB
Checkboxes;     `FbN{bNXڂ̉ɕ\邩ǂB
ChkCount;       `FbNĂm[h̐B
ChkItems;       `FbNĂm[hB
HoverTracking;  }EXzo[oݒBLȂ OnMouseHover NB
DropTarget;     ~XCHlXVꂽꍇAO DropTarget B

\bh
ClearCheck;           m[h̃`FbNׂĉB
StartHoverTracking;   }EXzo[oJnB
CancelHoverTracking;  }EXzo[o~B
ScrollBy;             J[\iwXN[WjɂXN[B

Cxg
OnCheck;      `FbN{bNX̏ԕύXɔB
OnBeginDrag;  DragMode = dmManual ̎ LVN_BEGINDRAG, LVN_BEGINRDRAG ʒm͂ۂɔB
OnMouseHover: J[\莞ԓȂƂɔB HoverTracking ~B

̂ق̃vpeBA\bhACxg TTreeView ƓB

   @\ǉXgRg[ *)

unit AfViews;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Classes, Vcl.Controls, Vcl.ExtCtrls,
  Vcl.ComCtrls, Winapi.CommCtrl;

const
  UM_REORDER = WM_USER + LVN_INSERTITEM;

type
  TDirectionTest = (dtOuter, dtInner, dtLeft, dtRight, dtUp, dtDown);

  TLVBeginDragEvent = procedure(Sender: TObject; Button: TMouseButton; Item: TListItem) of object;

  TListViewAf = class(TListView)
  private
    { Private 錾 }
    FSortIndex: Integer;
    FSortAscend: Boolean;
    FDrawArrow: TNotifyEvent;
    FHoverTimer: TTimer;  //Winapi.ActiveX.DoDragDrop }EXƐ肷邽߁AقɃbZ[W͂ȂB
    FOnBeginDrag: TLVBeginDragEvent;
    FOnMouseHover: TNotifyEvent;
    procedure SetSortIndex(const Value: Integer);
    procedure SetSortAscend(const Value: Boolean);
    function GetHoverTracking: Boolean;
    procedure SetHoverTracking(Value: Boolean);
    function GetDropTarget: TListItem;
    procedure SetDropTarget(Value: TListItem);
    procedure CNNotify(var Message: TWMNotifyLV); message CN_NOTIFY;
    procedure UMReorder(var Message: TMessage); message UM_REORDER;
  protected
    { Protected 錾 }
    procedure ColClick(Column: TListColumn); override;
    procedure WndProc(var Message: TMessage); override;
    procedure DoHoverTimeOut(Sender: TObject); virtual;
    procedure ReorderCorrectly;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetSortArrow(Index: Integer; Ascend: Boolean);
    procedure SortByIndex(Index: Integer; Ascend: Boolean);
    procedure StartHoverTracking(TimeOut: Cardinal = 0);
    procedure CancelHoverTracking;
    function ScrollBy(ScreenPos: TPoint; Range: Integer = 8): TDirectionTest;
    property HoverTracking: Boolean read GetHoverTracking write SetHoverTracking;
    property DropTarget: TListItem read GetDropTarget write SetDropTarget;
  published
    { Published 錾 }
    property SortIndex: Integer read FSortIndex write SetSortIndex;
    property SortAscend: Boolean read FSortAscend write SetSortAscend;
    property OnDrawArrow: TNotifyEvent read FDrawArrow write FDrawArrow;
    property OnBeginDrag: TLVBeginDragEvent read FOnBeginDrag write FOnBeginDrag;
    property OnMouseHover: TNotifyEvent read FOnMouseHover write FOnMouseHover;
  end;

  TTreeNodeHelper = class helper for TTreeNode
  private
    { Private 錾 }
    function GetChecked: Boolean;
    procedure SetChecked(Value: Boolean);
    function GetBold: Boolean;
    procedure SetBold(Value: Boolean);
  public
    { Public 錾 }
    property Checked: Boolean read GetChecked write SetChecked;
    property Bold: Boolean read GetBold write SetBold;
  end;

  TTVBeginDragEvent = procedure(Sender: TObject;
    Button: TMouseButton; Node: TTreeNode; Pt: TPoint) of object;

  TTreeViewAf = class(TTreeView)
  private
    { Private 錾 }
    FCheckboxes: Boolean;
    FBoxImages: TImageList;
    FChecks: TList;
    FHoverTimer: TTimer;
    FOnCheck: TTVChangedEvent;
    FOnBeginDrag: TTVBeginDragEvent;
    FOnMouseHover: TNotifyEvent;
    procedure SetCheckboxes(Value: Boolean);
    function GetChkCount: Integer;
    function GetChkItems(Index: Integer): TTreeNode;
    function GetHoverTracking: Boolean;
    procedure SetHoverTracking(Value: Boolean);
    function GetDropTarget: TTreeNode;
    procedure SetDropTarget(Value: TTreeNode);
    function GetHoverTimeOut: Cardinal;
    procedure SetHoverTimeOut(Value: Cardinal);
    procedure CNNotify(var Message: TWMNotifyTV); message CN_NOTIFY;
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure Loaded; override;
    procedure SetDragMode(Value: TDragMode); override;
    procedure DoCheck(Node: TTreeNode); virtual;
    procedure DoHoverTimeOut(Sender: TObject); virtual;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure ClearCheck;
    procedure StartHoverTracking(TimeOut: Cardinal = 0);
    procedure CancelHoverTracking;
    function ScrollBy(ScreenPos: TPoint; Range: Integer = 8): TDirectionTest;
    property ChkCount: Integer read GetChkCount;
    property ChkItems[Index: Integer]: TTreeNode read GetChkItems;
    property HoverTracking: Boolean read GetHoverTracking write SetHoverTracking;
    property DropTarget: TTreeNode read GetDropTarget write SetDropTarget;
  published
    { Published 錾 }
    property Checkboxes: Boolean read FCheckboxes write SetCheckboxes default True;
    property HoverTimeOut: Cardinal read GetHoverTimeOut write SetHoverTimeOut default 400;
    property OnCheck: TTVChangedEvent read FOnCheck write FOnCheck;
    property OnBeginDrag: TTVBeginDragEvent read FOnBeginDrag write FOnBeginDrag;
    property OnMouseHover: TNotifyEvent read FOnMouseHover write FOnMouseHover;
  end;

const
  TVIS_CHECKED = $2000;

procedure Register;

implementation

uses
  System.Types;

{ TListViewAf }

constructor TListViewAf.Create(AOwner: TComponent);
begin
  inherited;

  FSortIndex := -1;
  FSortAscend := True;
  FHoverTimer := TTimer.Create(Self);
  with FHoverTimer do
  begin
    Enabled := False;
    Interval := 400;
    OnTimer := DoHoverTimeOut;
  end;
end;

destructor TListViewAf.Destroy;
begin

  inherited;
end;

procedure TListViewAf.SetSortIndex(const Value: Integer);
begin
  if FSortIndex <> Value then
  begin
    if SortType = stNone then
      SortByIndex(Value, FSortAscend)
    else
      SetSortArrow(Value, FSortAscend);
  end;
end;

procedure TListViewAf.SetSortAscend(const Value: Boolean);
begin
  if FSortAscend <> Value then
  begin
    if SortType = stNone then
      SortByIndex(FSortIndex, Value)
    else
      SetSortArrow(FSortIndex, Value);
  end;
end;

function TListViewAf.GetHoverTracking: Boolean;
begin
  Result := FHoverTimer.Enabled;
end;

procedure TListViewAf.SetHoverTracking(Value: Boolean);
begin
  FHoverTimer.Enabled := Value;
end;

function TListViewAf.GetDropTarget: TListItem;
begin
  Result := inherited DropTarget;
end;

procedure TListViewAf.SetDropTarget(Value: TListItem);
var
  CurrentTarget: TListItem;
begin
  CurrentTarget := DropTarget;
  if Value <> CurrentTarget then
  begin
    if Assigned(CurrentTarget) then
      CurrentTarget.DropTarget := False;
    inherited DropTarget := Value;
  end;
end;

type
  TListItemsHacker = class(TListItems);

procedure TListViewAf.CNNotify(var Message: TWMNotifyLV);
var
  Button: TMouseButton;
  Item: TListItem;
begin
  case Message.NMHdr.code of
    LVN_INSERTITEM:
    begin
      PostMessage(Handle, UM_REORDER, 0, 0);
    end;
    LVN_BEGINDRAG, LVN_BEGINRDRAG:
    begin
      if Assigned(FOnBeginDrag) then
      begin
        if Message.NMHdr.code = LVN_BEGINDRAG then
          Button := mbLeft
        else
          Button := mbRight;
        Item := TListItemsHacker(Items).GetItem(Message.NMListView.iItem);
        FOnBeginDrag(Self, Button, Item);
      end;
    end;
  end;

  inherited;
end;

procedure TListViewAf.UMReorder(var Message: TMessage);
begin
  //O[vr[|[g`ŎgƁAACȇ}ʒuw肵Ăɖɒǉ邽߁A
  //LVN_INSERTITEM ʒmACfbNXɕגBWindows ̖H
  if (ViewStyle = vsReport) and GroupView then
    ReorderCorrectly;
end;

procedure TListViewAf.ColClick(Column: TListColumn);
var
  Ascending: Boolean;
begin
  if FSortIndex = Column.Index then
    Ascending := not FSortAscend
  else
    Ascending := FSortAscend;
  if SortType = stNone then SortByIndex(Column.Index, Ascending);

  inherited;
end;

procedure TListViewAf.WndProc(var Message: TMessage);
begin
  inherited;

  case Message.Msg of
    WM_NOTIFY:
    begin
      //J̕ς
      if PNMHdr(Message.LParam).code = HDN_ENDTRACK then
        SetSortArrow(FSortIndex, FSortAscend);
    end;
  end;
end;

procedure TListViewAf.DoHoverTimeOut(Sender: TObject);
begin
  FHoverTimer.Enabled := False;

  if Assigned(FOnMouseHover) then
    FOnMouseHover(Self);
end;

function CorrectlySortProc(Item1, Item2: TListItem; ParamSort: Integer): integer; stdcall;
begin
  if Item1.Index < Item2.Index then
    Result := -1
  else if Item1.Index > Item2.Index then
    Result := 1
  else
    Result := 0;
end;

procedure TListViewAf.ReorderCorrectly;
begin
  Items.BeginUpdate;
  try
    CustomSort(@CorrectlySortProc, 0);
  finally
    Items.EndUpdate;
  end;
end;

procedure TListViewAf.SetSortArrow(Index: Integer; Ascend: Boolean);
var
  Hnd: THandle;
  Item: THDItem;
begin
  Hnd := ListView_GetHeader(Handle);

  if FSortIndex in [0..Columns.Count - 1] then
  begin
    Item.Mask := HDI_FORMAT;
    Header_GetItem(Hnd, FSortIndex, Item);
    Item.fmt := Item.fmt and not HDF_SORTUP;
    Item.fmt := Item.fmt and not HDF_SORTDOWN;
    Header_SetItem(Hnd, FSortIndex, Item);
  end;

  FSortIndex := Index;
  FSortAscend := Ascend;

  if FSortIndex in [0..Columns.Count - 1] then
  begin
    Item.Mask := HDI_FORMAT;
    Header_GetItem(Hnd, FSortIndex, Item);
    if FSortAscend then
      Item.fmt := Item.fmt or HDF_SORTUP
    else
      Item.fmt := Item.fmt or HDF_SORTDOWN;
    Header_SetItem(Hnd, FSortIndex, Item);
  end;

  if Assigned(FDrawArrow) then
    FDrawArrow(Self);
end;

function AscendingSortFunc(Item1, Item2: TListItem; Param: Integer): Integer; stdcall;
begin
  Result := 0;
  if Assigned(Item1) and Assigned(Item2) then
    case Param of
      0: Result := CompareText(Item2.Caption, Item1.Caption);
    else
      Result := CompareText(Item2.SubItems[Param - 1], Item1.SubItems[Param - 1]);
    end;
end;

function DescendingSortFunc(Item1, Item2: TListItem; Param: Integer): Integer; stdcall;
begin
  Result := 0;
  if Assigned(Item1) and Assigned(Item2) then
    case Param of
      0: Result := CompareText(Item1.Caption, Item2.Caption);
    else
      Result := CompareText(Item1.SubItems[Param - 1], Item2.SubItems[Param - 1]);
    end;
end;

procedure TListViewAf.SortByIndex(Index: Integer; Ascend: Boolean);
begin
  Items.BeginUpdate;
  try
    if (Index <> FSortIndex) or (Ascend <> FSortAscend) then
      SetSortArrow(Index, Ascend);
    if Index in [0..Columns.Count - 1] then
    begin
      if Assigned(OnCompare) then
        CustomSort(nil, Index)
      else
      begin
        if Ascend then
          CustomSort(@AscendingSortFunc, Index)
        else
          CustomSort(@DescendingSortFunc, Index);
      end;
    end;
  finally
    Items.EndUpdate;
  end;
end;

procedure TListViewAf.StartHoverTracking(TimeOut: Cardinal = 0);
begin
  if TimeOut = 0 then
    TimeOut := 400;
  with FHoverTimer do
  begin
    Interval := TimeOut;
    Enabled := True;
  end;
end;

procedure TListViewAf.CancelHoverTracking;
begin
  FHoverTimer.Enabled := False;
end;

function TListViewAf.ScrollBy(ScreenPos: TPoint; Range: Integer = 8): TDirectionTest;
var
  Pt: TPoint;
  Rt: TRect;
  HeaderWnd: HWND;
  HeaderRt: TRect;
  Info: TScrollInfo;
begin
  Pt := ScreenToClient(ScreenPos);
  Rt := ClientRect;
  if ViewStyle = vsReport then
  begin
    HeaderWnd := ListView_GetHeader(Handle);
    if Header_GetItemRect(HeaderWnd, 0, @HeaderRt) then
      Rt.Inflate(0, -HeaderRt.Height, 0, 0);
  end;
  if Rt.Contains(Pt) then
  begin
    Rt.Inflate(-Range, -Range);
    if Pt.X < Rt.Left then
      Result := dtLeft
    else if Pt.X > Rt.Right then
      Result := dtRight
    else if Pt.Y < Rt.Top then
      Result := dtUp
    else if Pt.Y > Rt.Bottom then
      Result := dtDown
    else
      Result := dtInner;
  end
  else
    Result := dtOuter;

  Info.cbSize := SizeOf(TScrollInfo);
  Info.fMask := SIF_ALL;
  case Result of
    dtLeft:
    begin
      GetScrollInfo(Handle, SB_HORZ, Info);
      if Info.nPos > Info.nMin then
        Perform(WM_HSCROLL, SB_LINELEFT, 0)
      else
        Result := dtInner;
    end;
    dtRight:
    begin
      GetScrollInfo(Handle, SB_HORZ, Info);
      if (Info.nPos + Integer(Info.nPage)) <= Info.nMax then
        Perform(WM_HSCROLL, SB_LINERIGHT, 0)
      else
        Result := dtInner;
    end;
    dtUp:
    begin
      GetScrollInfo(Handle, SB_VERT, Info);
      if Info.nPos > Info.nMin then
        Perform(WM_VSCROLL, SB_LINEUP, 0)
      else
        Result := dtInner;
    end;
    dtDown:
    begin
      GetScrollInfo(Handle, SB_VERT, Info);
      if (Info.nPos + Integer(Info.nPage)) <= Info.nMax then
        Perform(WM_VSCROLL, SB_LINEDOWN, 0)
      else
        Result := dtInner;
    end;
  end;
end;

{ TTreeNodeHelper }

function TTreeNodeHelper.GetChecked: Boolean;
var
  Item: TTVItem;
begin
  Result := False;
  if not Deleting then
  begin
    FillChar(Item, SizeOf(Item), 0);
    with Item do
    begin
      mask := TVIF_STATE;
      hItem := ItemId;
    end;
    if TreeView_GetItem(Handle, Item) then
      Result := (Item.State and TVIS_CHECKED) > 0;
  end;
end;

procedure TTreeNodeHelper.SetChecked(Value: Boolean);
var
  Item: TTVItem;
begin
  if not Deleting then
  begin
    FillChar(Item, SizeOf(Item), 0);
    with Item do
    begin
      mask := TVIF_STATE;
      hItem := ItemId;
      if Value then
        state := TVIS_CHECKED
      else
        state := TVIS_CHECKED shr 1;
      stateMask := TVIS_STATEIMAGEMASK;
    end;

    TreeView_SetItem(Handle, Item);
  end;
end;

function TTreeNodeHelper.GetBold: Boolean;
var
  Item: TTVItem;
begin
  Result := False;
  if not Deleting then
  begin
    FillChar(Item, SizeOf(Item), 0);
    with Item do
    begin
      mask := TVIF_STATE;
      hItem := ItemID;
    end;
    if TreeView_GetItem(Handle, Item) then
      Result := (Item.State and TVIS_BOLD) > 0;
  end;
end;

procedure TTreeNodeHelper.SetBold(Value: Boolean);
var
  Item: TTVItem;
begin
  if not Deleting then
  begin
    FillChar(Item, SizeOf(Item), 0);
    with Item do
    begin
      mask := TVIF_STATE;
      hItem := ItemID;
      if Value then
        state := TVIS_BOLD
      else
        state := 0;
      stateMask := TVIS_BOLD;
    end;
    TreeView_SetItem(Handle, Item);
  end;
end;

{ TTreeViewAf }

constructor TTreeViewAf.Create(AOwner: TComponent);
begin
  inherited;

  FCheckboxes := True;
  FBoxImages := TImageList.Create(Self);
  FChecks := TList.Create;
  FHoverTimer := TTimer.Create(Self);
  with FHoverTimer do
  begin
    Enabled := False;
    Interval := 400;
    OnTimer := DoHoverTimeOut;
  end;
end;

destructor TTreeViewAf.Destroy;
begin
  FChecks.Free;

  inherited;
end;

procedure TTreeViewAf.SetCheckboxes(Value: Boolean);
begin
  if FCheckboxes <> Value then
  begin
    FCheckboxes := Value;
    RecreateWnd;
    if FCheckboxes then
      SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) or TVS_CHECKBOXES);
  end;
end;

function TTreeViewAf.GetChkCount: Integer;
begin
  Result := FChecks.Count;
end;

function TTreeViewAf.GetChkItems(Index: Integer): TTreeNode;
begin
  Result := TTreeNode(FChecks.Items[Index])
end;

function TTreeViewAf.GetHoverTracking: Boolean;
begin
  Result := FHoverTimer.Enabled;
end;

procedure TTreeViewAf.SetHoverTracking(Value: Boolean);
begin
  FHoverTimer.Enabled := Value;
end;

function TTreeViewAf.GetDropTarget: TTreeNode;
begin
  Result := inherited DropTarget;
end;

procedure TTreeViewAf.SetDropTarget(Value: TTreeNode);
var
  CurrentTarget: TTreeNode;
begin
  CurrentTarget := DropTarget;
  if Value <> CurrentTarget then
  begin
    if Assigned(CurrentTarget) then
      CurrentTarget.DropTarget := False;
    inherited DropTarget := Value;
  end;
end;

function TTreeViewAf.GetHoverTimeOut: Cardinal;
begin
  Result := FHoverTimer.Interval;
end;

procedure TTreeViewAf.SetHoverTimeOut(Value: Cardinal);
begin
  FHoverTimer.Interval := Value;
end;

procedure TTreeViewAf.CNNotify(var Message: TWMNotifyTV);
var
  Button: TMouseButton;
  Node: TTreeNode;
  Pt: TPoint;
begin
  case Message.NMHdr.code of
    TVN_BEGINDRAG, TVN_BEGINRDRAG:
    begin
      if DragMode = dmManual then
      begin
        if Assigned(FOnBeginDrag) then
        begin
          if Message.NMHdr.code = TVN_BEGINDRAG then
            Button := mbLeft
          else
            Button := mbRight;
          Node := Items.GetNode(Message.NMTreeView.itemNew.hItem);
          Pt := Message.NMTreeView.ptDrag;
          FOnBeginDrag(Self, Button, Node, Pt);
        end;
        Exit;
      end;
    end;
    TVN_ITEMCHANGED:
    begin
      with PNMTVItemChange(Message.NMHdr)^ do
      begin
        Node := Items.GetNode(hItem);
        if Assigned(Node) then
        begin
          if (TVIS_USERMASK and uStateNew) <> (TVIS_USERMASK and uStateOld) then
            DoCheck(Node);
        end;
      end;
    end;
    TVN_DELETEITEM:
    begin
      Node := Items.GetNode(Message.NMTreeView.itemOld.hItem);
      if Assigned(Node) then
        FChecks.Remove(Node);
    end;
  end;

  inherited;
end;

procedure TTreeViewAf.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);

  // DragMode = dmManual ł TVN_BEGINDRAG ʒm𔭐B
  Params.Style := Params.Style and not TVS_DISABLEDRAGDROP;
end;

procedure TTreeViewAf.Loaded;
begin
  if FCheckboxes then
  begin
    SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) or TVS_CHECKBOXES);

    if StateImages = nil then
    begin
      FBoxImages.Handle := TreeView_GetImageList(Handle, TVSIL_STATE);
      StateImages := FBoxImages;
    end;
  end;

  inherited;
end;

procedure TTreeViewAf.SetDragMode(Value: TDragMode);
begin
  inherited;

  if DragMode = dmManual then
    SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not TVS_DISABLEDRAGDROP);
end;

procedure TTreeViewAf.DoCheck(Node: TTreeNode);
begin
  if FCheckboxes then
  begin
    if Assigned(Node) and not Node.Deleting then
    begin
      if Node.Checked then
      begin
        if Node.StateIndex < 2 then
          Node.StateIndex := 2;
        if FChecks.IndexOf(Node) < 0 then
          FChecks.Add(Node);
      end
      else
      begin
        if Node.StateIndex >= 2 then
          Node.StateIndex := 1;
        FChecks.Remove(Node);
      end;
    end;
    if Assigned(FOnCheck) then
      FOnCheck(Self, Node);
  end;
end;

procedure TTreeViewAf.DoHoverTimeOut(Sender: TObject);
begin
  FHoverTimer.Enabled := False;

  if Assigned(FOnMouseHover) then
    FOnMouseHover(Self);
end;

procedure TTreeViewAf.ClearCheck;
var
  i: Integer;
begin
  for i := ChkCount - 1 downto 0 do
    ChkItems[i].Checked := False;
end;

procedure TTreeViewAf.StartHoverTracking(TimeOut: Cardinal = 0);
begin
  if TimeOut = 0 then
    TimeOut := 400;
  with FHoverTimer do
  begin
    Interval := TimeOut;
    Enabled := True;
  end;
end;

procedure TTreeViewAf.CancelHoverTracking;
begin
  FHoverTimer.Enabled := False;
end;

function TTreeViewAf.ScrollBy(ScreenPos: TPoint; Range: Integer = 8): TDirectionTest;
var
  Pt: TPoint;
  Rt: TRect;
  Info: TScrollInfo;
begin
  Pt := ScreenToClient(ScreenPos);
  Rt := ClientRect;
  if Rt.Contains(Pt) then
  begin
    Rt.Inflate(-Range, -Range);
    if Pt.X < Rt.Left then
      Result := dtLeft
    else if Pt.X > Rt.Right then
      Result := dtRight
    else if Pt.Y < Rt.Top then
      Result := dtUp
    else if Pt.Y > Rt.Bottom then
      Result := dtDown
    else
      Result := dtInner;
  end
  else
    Result := dtOuter;

  Info.cbSize := SizeOf(TScrollInfo);
  Info.fMask := SIF_ALL;
  case Result of
    dtLeft:
    begin
      GetScrollInfo(Handle, SB_HORZ, Info);
      if Info.nPos > Info.nMin then
        Perform(WM_HSCROLL, SB_LINELEFT, 0)
      else
        Result := dtInner;
    end;
    dtRight:
    begin
      GetScrollInfo(Handle, SB_HORZ, Info);
      if (Info.nPos + Integer(Info.nPage)) <= Info.nMax then
        Perform(WM_HSCROLL, SB_LINERIGHT, 0)
      else
        Result := dtInner;
    end;
    dtUp:
    begin
      GetScrollInfo(Handle, SB_VERT, Info);
      if Info.nPos > Info.nMin then
        Perform(WM_VSCROLL, SB_LINEUP, 0)
      else
        Result := dtInner;
    end;
    dtDown:
    begin
      GetScrollInfo(Handle, SB_VERT, Info);
      if (Info.nPos + Integer(Info.nPage)) <= Info.nMax then
        Perform(WM_VSCROLL, SB_LINEDOWN, 0)
      else
        Result := dtInner;
    end;
  end;
end;

procedure Register;
begin
  RegisterComponents('Samples', [TListViewAf, TTreeViewAf]);
end;

end.
