(*	TTextGrid

Ver, 1.00 2006/11/16 ^B
Ver, 1.01 2009/02/04 낢gB
Ver, 1.02 2009/03/26 s/̑}/폜̎dlύXB
Ver, 1.03 2010/05/14 goEnter IvVǉB
Ver, 1.04 2014/03/10 goReadOnly IvVp~BeύXCxg̒ǉBEditStyle ֌W̌JB
Ver, 1.05 2016/03/21 GridColumns gAp~B}`ZNgΉBzC[CxgǉB
Ver, 1.06 2016/07/01 TColSection, TRowSection  Tag vpeBǉB
Ver, 1.07 2016/12/04 }`ZNg֘ȀCAύXBOptionsEx gBDrawCell ֌W̌JB
Ver, 1.08 2016/12/26 DoMouseWheelDown CB
Ver, 1.09 2017/05/18 DrawCell CB

gStringGrid

vpeB
InplaceEditor;      Cv[XGfB^B
OptionsEx;          Options ̊gB
  goHideSelection:  tH[JX̃Rg[ɈړĂCv[XGfB^͈̔͑I\𑱂B
                    TEdit.HideSelection ƓB
  goEnter:          [Enter] L[ [Shift] + [Enter] L[gĊeZԂړłB
  goMultiSelect:    \vZɃZ𕡐IłB
  goScrollWheel:    zC[̉]A`gŃXN[B
  goCellHint:       eLXg Hint ɕ\B\̂ ShowHint ŐB
  goFixedRowSizing: Œ̃TCYύXB
  goFixedColSizing: Œs̃TCYύXB
ColSections;        ̃vpeBB
  Alignment:        Z̔̕zuB
  Caption:          ԏ̌ŒZ̕B
  Width:            Z̕BDefaultColWidth Ƃ͔񓯊B
  Tag:              IvV̐lBTComponent.Tag ƓB
RowSections;        s̃vpeBB
  Caption:          ԍ̌ŒZ̕B
  Height:           Z̍BDefaultRowHeight Ƃ͔񓯊B
  Tag:              IvV̐lBTComponent.Tag ƓB
Selects;            Z̑IԁB
SelBoundary;        IZ͈̔́BgoMultiSelect  Vcl.Grids.TCustomGrid.Selection ƓB
                    goMultiSelect L Selection ύXꍇA͈͂𓯂ɂB

\bh
MoveColumn;     ړB
MoveRow;        sړB
DeleteColumn;   폜B
DeleteRow;      s폜B
InsertColumn;   }B
InsertRow;      s}B
EnumSelects;    IZ̗񋓎qB͕sB

Cxg
OnColWidthsChanged;   ̕ύXB
OnRowHeightsChanged;  s̍ύXB
OnGetEditStyle:       InplaceEditor ̌`ݒBVcl.Grids.TInplaceEditList.EditStyle QƁB
OnGetPickListItems:   EditStyle = esPickList ̑IXgݒB
OnEditButtonClick:    EditStyle = esEllipsis Ƀ{^ꂽB
OnEditExit;           ̓tH[JXCv[XGfB^ʂ̃Rg[ֈڂB
                      InplaceEditor ̓̓tH[JX֌W̃CxǵADelphiXE2 ̏ꍇ
                      OnGetEditStyle, OnGetEditMask, OnGetEditText, OnSetEditText, OnEditExit
                      ̏ɔB
OnCellsChange;        Z̒l̕ύXBR[hlύXꍇɂBȉOƂB
OnObjectsChange;      IuWFNg̕ύXB
OnColsChange;         ̒l̕ύXB
OnRowsChange;         s̒l̕ύXB
OnMouseTilt;          zC[`gB`g킸B
OnMouseTiltRight;     zC[E`gB
OnMouseTiltLeft;      zC[`gB
OnMouseWheel;         zC[]B]킸B

̂ق̃vpeBA\bhACxg TStringGrid ƓB

[`
IsSingleRect; TGridRect ̃ZPƂB
GridCoord;    TGridCoord 쐬
GridRect;     TGridRect 쐬B
CoordInRect;  Z͈͓ɂ邩BSystem.Types.PtInRect ̃ZŁB

ӎ
bZ[WɂċĂꂽjɁB

	gXgOObh*)

unit TextGrid;

interface

uses
  System.SysUtils, System.Classes, System.Types, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Grids,
  Winapi.Messages, Winapi.Windows, Vcl.StdCtrls, System.Generics.Collections;

type
  TColSection = class(TCollectionItem)
  private
    { Private 錾 }
    FAlignment: TAlignment;
    FCaption: string;
    FWidth: Integer;
    FTag: Integer;
  public
    { Public 錾 }
    constructor Create(Collection: TCollection); override;
    procedure Assign(Value: TPersistent); override;
    procedure SetAlignment(Value: TAlignment);
    procedure SetCaption(Value: string);
    procedure SetWidth(Value: Integer);
  published
    { Published 錾 }
    property Alignment: TAlignment read FAlignment write SetAlignment;
    property Caption: string read FCaption write SetCaption;
    property Width: Integer read FWidth write SetWidth;
    property Tag: Integer read FTag write FTag default 0;
  end;

  TRowSection = class(TCollectionItem)
  private
    { Private 錾 }
    FCaption: string;
    FHeight: Integer;
    FTag: Integer;
  public
    { Public 錾 }
    constructor Create(Collection: TCollection); override;
    procedure Assign(Value: TPersistent); override;
    procedure SetCaption(Value: string);
    procedure SetHeight(Value: Integer);
  published
    { Published 錾 }
    property Caption: string read FCaption write SetCaption;
    property Height: Integer read FHeight write SetHeight;
    property Tag: Integer read FTag write FTag default 0;
  end;

  TTextGrid = class;

  TColSections = class(TCollection)
  private
    { Private 錾 }
    FOwner: TTextGrid;
    procedure SetItems(Index: Integer; Value: TColSection);
    function GetItems(Index: Integer): TColSection;
  protected
    { Protected 錾 }
    procedure Update(Item: TCollectionItem); override;
    function GetOwner: TPersistent; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TTextGrid);
    function Add: TColSection;
    property Items[Index: Integer]: TColSection read GetItems write SetItems;
  end;

  TRowSections = class(TCollection)
  private
    { Private 錾 }
    FOwner: TTextGrid;
    procedure SetItems(Index: Integer; Value: TRowSection);
    function GetItems(Index: Integer): TRowSection;
  protected
    { Protected 錾 }
    procedure Update(Item: TCollectionItem); override;
    function GetOwner: TPersistent; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TTextGrid);
    function Add: TRowSection;
    property Items[Index: Integer]: TRowSection read GetItems write SetItems;
  end;

  TGridOptionEx = (goHideSelection, goEnter, goMultiSelect, goScrollWheel, goCellHint,
    goFixedRowSizing, goFixedColSizing);
  TGridOptionsEx = set of TGridOptionEx;

  TEditExitEvent = procedure(TSender: TObject; ACol, ARow: Integer) of object;
  TCellsChangeEvent = procedure(TSender: TObject; ACol, ARow: Integer) of object;
  TObjectsChangeEvent = procedure(TSender: TObject; ACol, ARow: Integer) of object;
  TColsChangeEvent = procedure(TSender: TObject; Index: Integer) of object;
  TRowsChangeEvent = procedure(TSender: TObject; Index: Integer) of object;
  TGetEditStyleEvent = procedure(TSender: TObject; ACol, ARow: Integer;
    var EditStyle: TEditStyle) of object;
  TGetPickListItemsEvent = procedure(TSender: TObject; ACol, ARow: Integer;
    Items: TStrings) of object;

  TTextGrid = class(TStringGrid)
  private
    { Private 錾 }
    FEditCol,
    FEditRow: Integer;
    FOptionsEx: TGridOptionsEx;
    FSizingCol,
    FFirstColWidth: Integer;
    FSizingRow,
    FFirstRowHeight: Integer;
    FColSections: TColSections;
    FRowSections: TRowSections;
    FSelects: TDictionary<TGridCoord, Boolean>;
    FOnColWidthsChanged,
    FOnRowHeightsChanged: TNotifyEvent;
    FOnEditExit: TEditExitEvent;
    FOnCellsChange: TCellsChangeEvent;
    FOnObjectsChange: TObjectsChangeEvent;
    FOnColsChange: TColsChangeEvent;
    FOnRowsChange: TRowsChangeEvent;
    FOnGetEditStyle: TGetEditStyleEvent;
    FOnGetPickListItems: TGetPickListItemsEvent;
    FOnEditButtonClick: TNotifyEvent;
    FOnMouseTilt: TMouseWheelEvent;
    FOnMouseTiltRight: TMouseWheelUpDownEvent;
    FOnMouseTiltLeft: TMouseWheelUpDownEvent;
    procedure WMCommand(var Message: TWMCommand); message WM_COMMAND;
    procedure CMHintShow(var Message: TCMHintShow); message CM_HINTSHOW;
    procedure SetOptionsEx(Value: TGridOptionsEx);
    procedure SetColSections(Value: TColSections);
    procedure SetRowSections(Value: TRowSections);
    function ColSizingCoord(X, Y: Integer): TGridCoord;
    function RowSizingCoord(X, Y: Integer): TGridCoord;
    procedure AddSelRange(ARect: TGridRect);
    procedure GetPickListItems(ACol, ARow: Integer; Items: TStrings);
    procedure EditButtonClick(Sender: TObject);
    function GetSelects(ACol, ARow: Integer): Boolean;
    procedure SetSelects(ACol, ARow: Integer; Value: Boolean);
    function GetSelection: TGridRect;
    procedure SetSelection(Value: TGridRect);
    function GetSelBoundary: TGridRect;
  protected
    { Protected 錾 }
    function CreateEditor: TInplaceEdit; override;
    procedure ColWidthsChanged; override;
    procedure RowHeightsChanged; override;
    procedure CalcDrawInfo(var DrawInfo: TGridDrawInfo);
    procedure CalcSizingState(X, Y: Integer; var State: TGridState;
      var Index: Longint; var SizingPos, SizingOfs: Integer;
      var FixedInfo: TGridDrawInfo); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: Char); override;
    procedure KeyUp(var Key: Word; Shift: TShiftState); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure DrawCell(ACol, ARow: Longint; ARect: TRect; AState: TGridDrawState); override;
    procedure SizeChanged(OldColCount, OldRowCount: Longint); override;
    function DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    function DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    function DoMouseTiltRight(Shift: TShiftState; MousePos: TPoint): Boolean; dynamic;
    function DoMouseTiltLeft(Shift: TShiftState; MousePos: TPoint): Boolean; dynamic;
    function DoMouseTilt(Shift: TShiftState; WheelDelta: Integer;
      MousePos: TPoint): Boolean; dynamic;
    procedure WndProc(var Message: TMessage); override;
    procedure SetEditText(ACol, ARow: Longint; const Value: string); override;
    function GetCells(ACol, ARow: Integer): string;
    procedure SetCells(ACol, ARow: Integer; const Value: string);
    function GetObjects(ACol, ARow: Integer): TObject;
    procedure SetObjects(ACol, ARow: Integer; Value: TObject);
    function GetCols(Index: Integer): TStrings;
    procedure SetCols(Index: Integer; Value: TStrings);
    function GetRows(Index: Integer): TStrings;
    procedure SetRows(Index: Integer; Value: TStrings);
    function GetEditStyle(ACol, ARow: Integer): TEditStyle; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure MoveColumn(FromIndex, ToIndex: Longint);
    procedure MoveRow(FromIndex, ToIndex: Longint);
    procedure DeleteColumn(ACol: Longint); override;
    procedure DeleteRow(ARow: Longint); override;
    procedure InsertColumn(ACol: Longint);
    procedure InsertRow(ARow: Longint);
    procedure DrawCellBackground(const ARect: TRect; AColor: TColor;
      AState: TGridDrawState; ACol, ARow: Integer); reintroduce;
    procedure DrawCellHighlight(const ARect: TRect;
      AState: TGridDrawState; ACol, ARow: Integer); reintroduce;
    function EnumSelects: TEnumerable<TGridCoord>;
    property InplaceEditor;
    property Cells[ACol, ARow: Integer]: string read GetCells write SetCells;
    property Objects[ACol, ARow: Integer]: TObject read GetObjects write SetObjects;
    property Cols[Index: Integer]: TStrings read GetCols write SetCols;
    property Rows[Index: Integer]: TStrings read GetRows write SetRows;
    property Selects[ACol, ARow: Integer]: Boolean read GetSelects write SetSelects;
    property Selection: TGridRect read GetSelection write SetSelection;
    property SelBoundary: TGridRect read GetSelBoundary;
  published
    { Published 錾 }
    property OptionsEx: TGridOptionsEx read FOptionsEx write SetOptionsEx default [goHideSelection];
    property ColSections: TColSections read FColSections write SetColSections;
    property RowSections: TRowSections read FRowSections write SetRowSections;
    property OnColWidthsChanged: TNotifyEvent read FOnColWidthsChanged write FOnColWidthsChanged;
    property OnRowHeightsChanged: TNotifyEvent read FOnRowHeightsChanged write FOnRowHeightsChanged;
    property OnGetEditStyle: TGetEditStyleEvent read FOnGetEditStyle write FOnGetEditStyle;
    property OnGetPickListItems: TGetPickListItemsEvent
      read FOnGetPickListItems write FOnGetPickListItems;
    property OnEditButtonClick: TNotifyEvent read FOnEditButtonClick write FOnEditButtonClick;
    property OnEditExit: TEditExitEvent read FOnEditExit write FOnEditExit;
    property OnCellsChange: TCellsChangeEvent read FOnCellsChange write FOnCellsChange;
    property OnObjectsChange: TObjectsChangeEvent read FOnObjectsChange write FOnObjectsChange;
    property OnColsChange: TColsChangeEvent read FOnColsChange write FOnColsChange;
    property OnRowsChange: TRowsChangeEvent read FOnRowsChange write FOnRowsChange;
    property OnMouseTilt: TMouseWheelEvent read FOnMouseTilt write FOnMouseTilt;
    property OnMouseTiltRight: TMouseWheelUpDownEvent read FOnMouseTiltRight write FOnMouseTiltRight;
    property OnMouseTiltLeft: TMouseWheelUpDownEvent read FOnMouseTiltLeft write FOnMouseTiltLeft;
    property OnMouseWheel;
  end;

function IsSingleRect(ARect: TGridRect): Boolean;
function GridCoord(AX, AY: Integer): TGridCoord;
function GridRect(ALeft, ATop, ARight, ABottom: Longint): TGridRect;
function CoordInRect(Coord: TGridCoord; Rect: TGridRect): Boolean;

const
  DrawCellOffset = 2;       //Z̕`ʃItZbgiڌjB
  DrawFixedCellOffset = 3;  //ŒZ̕`ʃItZbgB

procedure Register;

implementation

{ Routine }

function IsSingleRect(ARect: TGridRect): Boolean;
begin
  Result := (ARect.Left = ARect.Right) and (ARect.Top = ARect.Bottom);
end;

function GridCoord(AX, AY: Integer): TGridCoord;
begin
  with Result do
  begin
    X := AX;
    Y := AY;
  end;
end;

function GridRect(ALeft, ATop, ARight, ABottom: Longint): TGridRect;
begin
  with Result do
  begin
    Left := ALeft;
    Top := ATop;
    Right := ARight;
    Bottom := ABottom;
  end;
end;

function CoordInRect(Coord: TGridCoord; Rect: TGridRect): Boolean;
begin
  Result := (Coord.X in [Rect.Left..Rect.Right]) and (Coord.Y in [Rect.Top..Rect.Bottom]);
end;

{ TColSection }

constructor TColSection.Create(Collection: TCollection);
begin
  inherited Create(Collection);

  FAlignment := taLeftJustify;
  FCaption := '';
  FWidth := TTextGrid(Collection.Owner).DefaultColWidth;
  FTag := 0;
end;

procedure TColSection.Assign(Value: TPersistent);
begin
  if Value is TColSection then
  begin
    FAlignment := TColSection(Value).Alignment;
    FCaption := TColSection(Value).Caption;
    FWidth := TColSection(Value).Width;
    TTextGrid(Collection.Owner).Invalidate;
  end;

  inherited Assign(Value);
end;

procedure TColSection.SetAlignment(Value: TAlignment);
begin
  if FAlignment <> Value then
  begin
    FAlignment := Value;

    Changed(False);
  end;
end;

procedure TColSection.SetCaption(Value: string);
begin
  if FCaption <> Value then
  begin
    Collection.BeginUpdate;
    FCaption := Value;
    Collection.EndUpdate;

    Changed(False);
  end;
end;

procedure TColSection.SetWidth(Value: Integer);
begin
  if FWidth <> Value then
  begin
    FWidth := Value;

    Changed(False);
  end;
end;

{ TRowSection }

constructor TRowSection.Create(Collection: TCollection);
begin
  inherited Create(Collection);

  FCaption := '';
  FHeight := TTextGrid(Collection.Owner).DefaultRowHeight;
  FTag := 0;
end;

procedure TRowSection.Assign(Value: TPersistent);
begin
  if Value is TColSection then
  begin
    FCaption := TRowSection(Value).Caption;
    FHeight := TRowSection(Value).Height;
  end;

  inherited Assign(Value);
end;

procedure TRowSection.SetCaption(Value: string);
begin
  if FCaption <> Value then
  begin
    FCaption := Value;

    Changed(False);
  end;
end;

procedure TRowSection.SetHeight(Value: Integer);
begin
  if FHeight <> Value then
  begin
    FHeight := Value;

    Changed(False);
  end;
end;

{ TColSections }

constructor TColSections.Create(AOwner: TTextGrid);
begin
  inherited Create(TColSection);

  FOwner := AOwner;
end;

function TColSections.GetOwner: TPersistent;
begin
  Result := FOwner;
end;

function TColSections.GetItems(Index: Integer): TColSection;
begin
  Result := TColSection(inherited GetItem(Index));
end;

procedure TColSections.SetItems(Index: Integer; Value: TColSection);
begin
  inherited SetItem(Index, Value);
end;

function TColSections.Add: TColSection;
begin
  Result := TColSection(inherited Add);
end;

procedure TColSections.Update(Item: TCollectionItem);
begin
  inherited Update(Item);

  if (UpdateCount <= 0) and (FOwner.ColCount <> Count) then
    FOwner.ColCount := Count;
  FOwner.Invalidate;
end;

{ TRowSections }

constructor TRowSections.Create(AOwner: TTextGrid);
begin
  inherited Create(TRowSection);

  FOwner := AOwner;
end;

function TRowSections.GetOwner: TPersistent;
begin
  Result := FOwner;
end;

function TRowSections.GetItems(Index: Integer): TRowSection;
begin
  Result := TRowSection(inherited GetItem(Index));
end;

procedure TRowSections.SetItems(Index: Integer; Value: TRowSection);
begin
  inherited SetItem(Index, Value);
end;

function TRowSections.Add: TRowSection;
begin
  Result := TRowSection(inherited Add);
end;

procedure TRowSections.Update(Item: TCollectionItem);
begin
  inherited Update(Item);

  if (UpdateCount <= 0) and (FOwner.RowCount <> Count) then
    FOwner.RowCount := Count;
  FOwner.Invalidate;
end;

{ TTextGrid }

constructor TTextGrid.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FEditCol := -1;
  FEditRow := -1;
  FSizingCol := -1;
  FFirstColWidth := 64;
  FSizingRow := -1;
  FFirstRowHeight := 64;
  FOptionsEx := [goHideSelection];
  FColSections := TColSections.Create(Self);
  FRowSections := TRowSections.Create(Self);
  FSelects := TDictionary<TGridCoord, Boolean>.Create;
  SizeChanged(5, 5);
end;

destructor TTextGrid.Destroy;
begin
  FColSections.Free;
  FRowSections.Free;
  FSelects.Free;

  inherited Destroy;
end;

function TTextGrid.CreateEditor: TInplaceEdit;
begin
  inherited CreateEditor;

  Result := TInplaceEditList.Create(Self);
  TEdit(Result).HideSelection := goHideSelection in OptionsEx;
  TInplaceEditList(Result).OnGetPickListitems := GetPickListItems;
  TInplaceEditList(Result).OnEditButtonClick  := EditButtonClick;
end;

procedure TTextGrid.SetOptionsEx(Value: TGridOptionsEx);
begin
  if FOptionsEx <> Value then
  begin
    FOptionsEx := Value;
    InvalidateGrid;
  end;
end;

procedure TTextGrid.SetColSections(Value: TColSections);
begin
  if FColSections <> Value then
  begin
    FColSections := Value;
    Invalidate;
  end;
end;

procedure TTextGrid.SetRowSections(Value: TRowSections);
begin
  if FRowSections <> Value then
  begin
    FRowSections := Value;
    Invalidate;
  end;
end;

procedure TTextGrid.AddSelRange(ARect: TGridRect);
var
  i, j: Integer;
  Pt: TGridCoord;
begin
  for i := ARect.Left to ARect.Right do
  begin
    for j := ARect.Top to ARect.Bottom do
    begin
      Pt := GridCoord(i, j);
      if not FSelects.ContainsKey(Pt) then
        FSelects.Add(Pt, True);
    end;
  end;
end;

procedure TTextGrid.ColWidthsChanged;
begin
  inherited ColWidthsChanged;

  if Assigned(FOnColWidthsChanged) then
    FOnColWidthsChanged(Self);
end;

procedure TTextGrid.RowHeightsChanged;
begin
  inherited RowHeightsChanged;

  if Assigned(FOnRowHeightsChanged) then
    FOnRowHeightsChanged(Self);
end;

procedure TTextGrid.CalcDrawInfo(var DrawInfo: TGridDrawInfo);
begin
  inherited CalcDrawInfo(DrawInfo);

  { ACalcFixedInfo ̌ŒZ񕔂𒲐߂΁AŒZTCYł炵B
    ܂̂A擪Z̃TCY܂ݒłȂ̂ŁA
    Ƃ肠AϐŋLĂČォ珑߂đΉB }
end;

function TTextGrid.ColSizingCoord(X, Y: Integer): TGridCoord;
var
  CellPt: TGridCoord;
  CellRt, BoundRt: TRect;
  MousePt: TPoint;
begin
  Result := GridCoord(-1, -1);

  CellPt := MouseCoord(X, Y);
  CellRt := CellRect(CellPt.X, CellPt.Y);
  MousePt := Point(X, Y);

  BoundRt := Rect(CellRt.Left - GridLineWidth - 2, CellRt.Top - GridLineWidth - 2,
    CellRt.Left + 2, CellRt.Bottom + 2);
  if PtInRect(BoundRt, MousePt) then
  begin
    Result.X := CellPt.X - 1;
    Result.Y := CellPt.Y;
  end;
  BoundRt := Rect(CellRt.Right - GridLineWidth - 2, CellRt.Top - GridLineWidth - 2,
    CellRt.Right + 2, CellRt.Bottom + 2);
  if PtInRect(BoundRt, MousePt) then
  begin
    Result.X := CellPt.X;
    Result.Y := CellPt.Y;
  end;
end;

function TTextGrid.RowSizingCoord(X, Y: Integer): TGridCoord;
var
  CellPt: TGridCoord;
  CellRt, BoundRt: TRect;
  MousePt: TPoint;
begin
  Result := GridCoord(-1, -1);

  CellPt := MouseCoord(X, Y);
  CellRt := CellRect(CellPt.X, CellPt.Y);
  MousePt := Point(X, Y);

  BoundRt := Rect(CellRt.Left - GridLineWidth - 2, CellRt.Top - GridLineWidth - 2,
    CellRt.Right + 2, CellRt.Top + 2);
  if PtInRect(BoundRt, MousePt) then
  begin
    Result.X := CellPt.X;
    Result.Y := CellPt.Y - 1;
  end;
  BoundRt := Rect(CellRt.Left - GridLineWidth - 2, CellRt.Bottom - GridLineWidth - 2,
    CellRt.Right + 2, CellRt.Bottom + 2);
  if PtInRect(BoundRt, MousePt) then
  begin
    Result.X := CellPt.X;
    Result.Y := CellPt.Y;
  end;
end;

{ CalcSizingState iԂj
  X:         J[\ X WB
  Y:         J[\ Y WB
  State:     ObhCAEg̏ԁB
  Index:     TCYZBgsColSizing ͍sAgsRowSizing ͗̃CfbNXB
  SizingPos: TCYʒuBgsColSizing ͕AgsRowSizing ͍B
  SizingOfs: SizingPos ̋é͈B-3..+3 ͈̔͂ŉEij}CiXB
  FixedInfo: ZɊւ }
procedure TTextGrid.CalcSizingState(X, Y: Integer; var State: TGridState;
  var Index: Longint; var SizingPos, SizingOfs: Integer;
  var FixedInfo: TGridDrawInfo);
var
  Pt: TGridCoord;
  Rt: TRect;
begin
  inherited CalcSizingState(X, Y, State, Index, SizingPos, SizingOfs, FixedInfo);

  if goFixedColSizing in FOptionsEx then
  begin
    Pt := ColSizingCoord(X, Y);
    if (Pt.X >= 0) and (Pt.Y <= FixedRows) then
    begin
      Rt := CellRect(Pt.X, Pt.Y);
      State := gsColSizing;
      Index := Pt.X;
      SizingPos := Rt.Right;
      SizingOfs := Rt.Right - X;
    end;
  end;
  if goFixedRowSizing in FOptionsEx then
  begin
    Pt := RowSizingCoord(X, Y);
    if (Pt.Y >= 0) and (Pt.X <= FixedCols) then
    begin
      Rt := CellRect(Pt.X, Pt.Y);
      State := gsRowSizing;
      Index := Pt.Y;
      SizingPos := Rt.Bottom;
      SizingOfs := Rt.Bottom - Y;
    end;
  end;
end;

procedure TTextGrid.KeyDown(var Key: Word; Shift: TShiftState);
var
  RTLFactor: Integer;

  procedure FocusCol(NewCol: Integer);
  begin
    if NewCol in [FixedCols..ColCount - 1] then
      Col := NewCol;
  end;

  procedure FocusRow(NewRow: Integer);
  begin
    if NewRow in [FixedRows..RowCount - 1] then
      Row := NewRow;
  end;

begin
  if Key in [VK_PRIOR..VK_DOWN] then
  begin
    if (not (ssCtrl in Shift)) and (not (ssShift in Shift)) then
      FSelects.Clear;
    Invalidate;
  end;

  if ssCtrl in Shift then
  begin
    if not UseRightToLeftAlignment then
      RTLFactor := 1
    else
      RTLFactor := -1;
    case Key of
      VK_UP: FocusRow(Row - 1);
      VK_DOWN: FocusRow(Row + 1);
      VK_LEFT:
        if not (goRowSelect in Options) then
          FocusCol(Col - RTLFactor);
      VK_RIGHT:
        if not (goRowSelect in Options) then
          FocusCol(Col + RTLFactor);
    else
      inherited KeyDown(Key, Shift);
    end;
  end
  else
    inherited KeyDown(Key, Shift);
end;

procedure TTextGrid.KeyPress(var Key: Char);
var
  X, Y: Integer;
begin
  case Ord(Key) of
    VK_RETURN:
      if goEnter in OptionsEx then
      begin
        X := Col;
        Y := Row;
        if HiByte(GetKeyState(VK_SHIFT)) = 0 then
        begin
          Inc(X);
          if X >= ColCount then
          begin
            X := FixedCols;
            Inc(Y);
            if Y >= RowCount then
              Y := FixedRows;
          end;
        end
        else
        begin
          Dec(X);
          if X < FixedCols then
          begin
            X := ColCount - 1;
            Dec(Y);
            if Y < FixedRows then
              Y := RowCount - 1;
          end;
        end;
        Col := X;
        Row := Y;
      end;
  end;

  inherited KeyPress(Key);
end;

procedure TTextGrid.KeyUp(var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_PRIOR..VK_DOWN:
    begin
      if (not (ssCtrl in Shift)) and (not (ssShift in Shift)) then
        FSelects.Clear
      else if ssShift in Shift then
        AddSelRange(Selection);
      Invalidate;
    end;
    VK_SPACE:
    begin
      if ssCtrl in Shift then
      begin
        if IsSingleRect(Selection) and FSelects.ContainsKey(Selection.TopLeft) then
          FSelects.Remove(Selection.TopLeft)
        else
          AddSelRange(Selection);
      end
      else
      begin
        FSelects.Clear;
        AddSelRange(Selection);
      end;
      Invalidate;
    end;
  end;

  inherited KeyUp(Key, Shift);
end;

procedure TTextGrid.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Pt: TGridCoord;
begin
  if (not (ssCTRL in Shift)) and (not (ssSHIFT in Shift)) then
    FSelects.Clear;
  Invalidate;

  if goFixedColSizing in FOptionsEx then
  begin
    Pt := ColSizingCoord(X, Y);
    if (Pt.X >= 0) and (Pt.Y <= FixedRows) then
    begin
      FSizingCol := Pt.X;
      FFirstColWidth := ColWidths[0];
    end
    else
      FSizingCol := -1;
  end;
  if goFixedRowSizing in FOptionsEx then
  begin
    Pt := RowSizingCoord(X, Y);
    if (Pt.Y >= 0) and (Pt.Y <= FixedCols) then
    begin
      FSizingRow := Pt.Y;
      FFirstRowHeight := RowHeights[0];
    end
    else
      FSizingRow := -1;
  end;

  inherited MouseDown(Button, Shift, X, Y);
end;

procedure TTextGrid.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Rt: TRect;
begin
  if ssCtrl in Shift then
  begin
    if IsSingleRect(Selection) and FSelects.ContainsKey(Selection.TopLeft) then
      FSelects.Remove(Selection.TopLeft)
    else
      AddSelRange(Selection);
  end
  else if ssShift in Shift then
  begin
    AddSelRange(Selection);
  end
  else
  begin
    FSelects.Clear;
    AddSelRange(Selection);
  end;
  Invalidate;

  if goFixedColSizing in FOptionsEx then
    if FSizingCol >= 0 then
    begin
      ColWidths[0] := FFirstColWidth;
      Rt := CellRect(FSizingCol, 0);
      ColWidths[FSizingCol] := X - Rt.Left;
      FSizingCol := -1;
    end;
  if goFixedRowSizing in FOptionsEx then
    if FSizingRow >= 0 then
    begin
      RowHeights[0] := FFirstRowHeight;
      Rt := CellRect(0, FSizingRow);
      RowHeights[FSizingRow] := Y - Rt.Top;
      FSizingRow := -1;
    end;

  inherited MouseUp(Button, Shift, X, Y);
end;

procedure TTextGrid.DrawCell(ACol, ARow: Longint; ARect: TRect; AState: TGridDrawState);
var
  s: string;
  Offset: Integer;
  Flags: Integer;
begin
  if DefaultDrawing then
  begin
    s := Cells[ACol, ARow];
    if (ACol < FColSections.Count) and (ARow < FRowSections.Count) then
    begin
      if gdFixed in AState then
      begin
        Offset := DrawFixedCellOffset;
        if s = '' then
        begin
          if ARow = 0 then
            s := FColSections.Items[ACol].Caption;
          if ACol = 0 then
            s := FRowSections.Items[ARow].Caption;
        end;
      end
      else
      begin
        Offset := DrawCellOffset;
        if Selects[ACol, ARow] or (not IsSingleRect(Selection) and (gdSelected in AState)) then
          DrawCellHighlight(ARect, AState, ACol, ARow)
        else
          DrawCellBackground(ARect, Color, AState, ACol, ARow);
      end;
      InflateRect(ARect, -Offset, -Offset);
      Flags := DT_EDITCONTROL;
      case FColSections.Items[ACol].Alignment of
        taLeftJustify: Flags := Flags or DT_LEFT;
        taCenter: Flags := Flags or DT_CENTER;
        taRightJustify: Flags := Flags or DT_RIGHT;
      end;
      DrawTextEx(Canvas.Handle, PChar(s), Length(s), ARect, Flags, nil);
    end;
  end;

  if Assigned(OnDrawCell) then
    OnDrawCell(Self, ACol, ARow, ARect, AState);
end;

procedure TTextGrid.SizeChanged(OldColCount, OldRowCount: Longint);
begin
  FColSections.BeginUpdate;
  try
    while ColCount > FColSections.Count do
      FColSections.Add;
    while ColCount < FColSections.Count do
      FColSections.Items[FColSections.Count - 1].Free;
  finally
    FColSections.EndUpdate;
  end;

  FRowSections.BeginUpdate;
  try
    while RowCount > FRowSections.Count do
      FRowSections.Add;
    while RowCount < FRowSections.Count do
      FRowSections.Items[FRowSections.Count - 1].Free;
  finally
    FRowSections.EndUpdate;
  end;

  inherited SizeChanged(OldColCount, OldRowCount);
end;

procedure TTextGrid.WMCommand(var Message: TWMCommand);
begin
  inherited;

  case Message.NotifyCode of
    EN_SETFOCUS:
    begin
      FEditCol := Col;
      FEditRow := Row;
    end;
    EN_KILLFOCUS:
      if Assigned(FOnEditExit) then FOnEditExit(Self, FEditCol, FEditRow);
  end;
end;

procedure TTextGrid.CMHintShow(var Message: TCMHintShow);
var
  ACol, ARow: Integer;
  Offset: Integer;
  Extent: TSize;
begin
  if goCellHint in FOptionsEx then
  begin
    with Message.HintInfo^ do
    begin
      MouseToCell(CursorPos.X, CursorPos.Y, ACol, ARow);
      if (0 <= ACol) and (0 <= ARow) then
      begin
        if (ACol <= FixedCols) or (ARow <= FixedRows) then
          Offset := DrawFixedCellOffset
        else
          Offset := DrawCellOffset;
        Extent := Canvas.TextExtent(Cells[ACol, ARow]);
        if ((Extent.cx + Offset) > ColWidths[ACol]) or ((Extent.cy + Offset) > RowHeights[ARow]) then
        begin
          CursorRect := CellRect(ACol, ARow);
          HintStr := Cells[ACol, ARow];
          Message.Result := 0;
        end;
      end;
    end;

    if Message.Result <> 0 then
      inherited;
  end
  else
    inherited;
end;

function TTextGrid.DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  if goScrollWheel in FOptionsEx then
  begin
    Result := False;
    if Assigned(OnMouseWheelDown) then
      OnMouseWheelDown(Self, Shift, MousePos, Result);
    if not Result then
      Perform(WM_VSCROLL, SB_LINEDOWN, 0);
  end
  else
    Result := inherited DoMouseWheelDown(Shift, MousePos);
end;

function TTextGrid.DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  if goScrollWheel in FOptionsEx then
  begin
    Result := False;
    if Assigned(OnMouseWheelUp) then
      OnMouseWheelUp(Self, Shift, MousePos, Result);
    if not Result then
      Perform(WM_VSCROLL, SB_LINEUP, 0);
  end
  else
    Result := inherited DoMouseWheelUp(Shift, MousePos);
end;

function TTextGrid.DoMouseTiltRight(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := False;
  if Assigned(FOnMouseTiltRight) then
    FOnMouseTiltRight(Self, Shift, MousePos, Result);
  if not Result then
  begin
    if goScrollWheel in FOptionsEx then
      Perform(WM_HSCROLL, SB_LINERIGHT, 0)
    else
    begin
      if Col < ColCount - 1 then Col := Col + 1;
        Result := True;
    end;
  end;
end;

function TTextGrid.DoMouseTiltLeft(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := False;
  if Assigned(FOnMouseTiltLeft) then
    FOnMouseTiltLeft(Self, Shift, MousePos, Result);
  if not Result then
  begin
    if goScrollWheel in FOptionsEx then
      Perform(WM_HSCROLL, SB_LINELEFT, 0)
    else
    begin
      if Col > FixedCols then Col := Col - 1;
        Result := True;
    end;
  end;
end;

function TTextGrid.DoMouseTilt(Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint): Boolean;
begin
  Result := False;
  if Assigned(FOnMouseTilt) then
    FOnMouseTilt(Self, Shift, WheelDelta, MousePos, Result);
  if not Result then
  begin
    if SmallInt(WheelDelta) > 0 then
      Result := DoMouseTiltRight(Shift, MousePos)
    else
      Result := DoMouseTiltLeft(Shift, MousePos);
  end;
end;

procedure TTextGrid.WndProc(var Message: TMessage);
begin
  case Message.Msg of
    WM_MOUSEHWHEEL: //zC[`gB
    begin
      with Message do
        DoMouseTilt(KeysToShiftState(WParamLo), WParamHi, Point(LParamLo, LParamHi));
    end;
  end;

  inherited WndProc(Message);
end;

procedure TTextGrid.SetEditText(ACol, ARow: Longint; const Value: string);
var
  Chaneged: Boolean;
begin
  Chaneged := Value <> Cells[ACol, ARow];
  inherited SetEditText(ACol, ARow, Value);

  if Chaneged and Assigned(FOnCellsChange) then
    FOnCellsChange(Self, ACol, ARow);
end;

function TTextGrid.GetCells(ACol, ARow: Integer): string;
begin
  Result := inherited Cells[ACol, ARow];
end;

procedure TTextGrid.SetCells(ACol, ARow: Integer; const Value: string);
begin
  inherited Cells[ACol, ARow] := Value;
  if Assigned(FOnCellsChange) then
    FOnCellsChange(Self, ACol, ARow);
end;

function TTextGrid.GetObjects(ACol, ARow: Integer): TObject;
begin
  Result := inherited Objects[ACol, ARow];
end;

procedure TTextGrid.SetObjects(ACol, ARow: Integer; Value: TObject);
begin
  inherited Objects[ACol, ARow] := Value;
  if Assigned(FOnObjectsChange) then
    FOnObjectsChange(Self, ACol, ARow);
end;

function TTextGrid.GetCols(Index: Integer): TStrings;
begin
  Result := inherited Cols[Index];
end;

procedure TTextGrid.SetCols(Index: Integer; Value: TStrings);
begin
  inherited Cols[Index] := Value;
  if Assigned(FOnColsChange) then
    FOnColsChange(Self, Index);
end;

function TTextGrid.GetRows(Index: Integer): TStrings;
begin
  Result := inherited Rows[Index];
end;

procedure TTextGrid.SetRows(Index: Integer; Value: TStrings);
begin
  inherited Rows[Index] := Value;
  if Assigned(FOnRowsChange) then
    FOnRowsChange(Self, Index);
end;

function TTextGrid.GetEditStyle(ACol, ARow: Integer): TEditStyle;
begin
  Result := esSimple;
  if Assigned(FOnGetEditStyle) then
    FOnGetEditStyle(Self, ACol, ARow, Result);
end;

procedure TTextGrid.GetPickListItems(ACol, ARow: Integer; Items: TStrings);
begin
  if Assigned(FOnGetPickListItems) then
    FOnGetPickListItems(Self, ACol, ARow, Items);
end;

procedure TTextGrid.EditButtonClick(Sender: TObject);
begin
  if Assigned(FOnEditButtonClick) then
    FOnEditButtonClick(Sender);
end;

function TTextGrid.GetSelects(ACol, ARow: Integer): Boolean;
var
  Pt: TGridCoord;
begin
  Pt := GridCoord(ACol, ARow);
  if goMultiSelect in FOptionsEx then
    Result := FSelects.ContainsKey(Pt)
  else
    Result := CoordInRect(Pt, Selection);
end;

procedure TTextGrid.SetSelects(ACol, ARow: Integer; Value: Boolean);
var
  Pt: TGridCoord;
begin
  Pt := GridCoord(ACol, ARow);
  if Value then
  begin
    if not FSelects.ContainsKey(Pt) then
      FSelects.Add(Pt, True);
  end
  else
  begin
    if FSelects.ContainsKey(Pt) then
      FSelects.Remove(Pt);
  end;
  InvalidateGrid;
end;

function TTextGrid.GetSelection: TGridRect;
begin
  Result := inherited Selection;
end;

procedure TTextGrid.SetSelection(Value: TGridRect);
begin
  inherited Selection := Value;

  FSelects.Clear;
  AddSelRange(Value);
end;

function TTextGrid.GetSelBoundary: TGridRect;
var
  Pt: TGridCoord;
begin
  if goMultiSelect in FOptionsEx then
  begin
    Result := GridRect(ColCount, RowCount, 0, 0);
    for Pt in FSelects.Keys do
    begin
      if Result.Left > Pt.X then
        Result.Left := Pt.X;
      if Result.Top > Pt.Y then
        Result.Top := Pt.Y;
      if Result.Right < Pt.X then
        Result.Right := Pt.X;
      if Result.Bottom < Pt.Y then
        Result.Bottom := Pt.Y;
    end;
  end
  else
    Result := Selection;
end;

procedure TTextGrid.MoveColumn(FromIndex, ToIndex: Longint);
begin
  inherited MoveColumn(FromIndex, ToIndex);
end;

procedure TTextGrid.MoveRow(FromIndex, ToIndex: Longint);
begin
  inherited MoveRow(FromIndex, ToIndex);
end;

procedure TTextGrid.DeleteColumn(ACol: Longint);
var
  i: Integer;
begin
  i := Col;
  Cols[ACol].Text := '';

  inherited DeleteColumn(ACol);

  if i >= ColCount then
    Dec(i);
  FocusCell(i, Row, True);  //ZĐݒ肵Ȃƕ\ȂB
end;

procedure TTextGrid.DeleteRow(ARow: Longint);
var
  i: Integer;
begin
  i := Row;
  Rows[ARow].Text := '';

  inherited DeleteRow(ARow);

  if i >= RowCount then
    Dec(i);
  FocusCell(Col, i, True);  //O炱H
end;

procedure TTextGrid.InsertColumn(ACol: Longint);
begin
  ColCount := ColCount + 1;
  Cols[ColCount - 1].Text := '';
  MoveColumn(ColCount - 1, ACol);
end;

procedure TTextGrid.InsertRow(ARow: Longint);
begin
  RowCount := RowCount + 1;
  Rows[RowCount - 1].Text := '';
  MoveRow(RowCount - 1, ARow);
end;

procedure TTextGrid.DrawCellBackground(const ARect: TRect; AColor: TColor;
  AState: TGridDrawState; ACol, ARow: Integer);
begin
  inherited DrawCellBackground(ARect, AColor, AState, ACol, ARow);
end;

procedure TTextGrid.DrawCellHighlight(const ARect: TRect;
  AState: TGridDrawState; ACol, ARow: Integer);
begin
  inherited DrawCellHighlight(ARect, AState, ACol, ARow);
end;

function TTextGrid.EnumSelects: TEnumerable<TGridCoord>;
begin
  Result := FSelects.Keys;
end;

procedure Register;
begin
  RegisterComponents('Samples', [TTextGrid]);
end;

end.
