(* Added feature ComboBox

Ver, 1.00 2006/05/13 ^B
Ver, 1.01 2006/11/30 UpdateHistory, ToolTips ǉB
Ver, 1.02 2012/03/11 ܂ AddHistory ̃oOCB
Ver, 1.03 2016/09/26 XV̎dlύXB
Ver, 1.04 2016/12/03 ToolTips vpeB TextTip ɉA߁B
Ver, 1.05 2020/10/02 FX₵̂ŁAHistoryBox.THistoryComboBox  AfCombo.TComboBoxAf ɉB
Ver, 1.06 2020/10/29 AutoCompleteListOptions ǉBTWFXg̏CB
Ver, 1.07 2020/12/13 TWFXg\̓G^[ƃGXP[vL[󂯎悤ɏCB

TComboBoxAf
@\ǉR{{bNXB

vpeB
AutoCompleteOptions;      IAutoComplete gp̃I[gRv[gIvVB
                          acoAutoSuggest, acoAutoAppend  AutoComplete, AutoDropDown ͔rB
AutoCompleteSource;       IAutoComplete gp̃I[gRv[g\[XB
AutoCompleteListOptions;  AutoCompleteSource = acsISF ̒ǉIvVB
WorkingDirectory;         AutoCompleteSource = acsISF ̃I[gRv[gΏۃfBNgB
SuggestDropedDown;        IAutoComplete ̃hbv_EXg̕\ԁBƂ肠A[hI[B
MaxCount;                 ̍ő吔B[ȉ̏ꍇAB
DropDownWidth;            hbv_EXg̕B
                          [̏ꍇAGfBbgƓB}CiX̏ꍇA̍ő啶B
TextTip;                   Text  Hint ɕ\B\̂ ShowHint ŐB

\bh
PushHistory;    ̐擪ɕǉAText vpeBXVBɕύXʒuԂB
UpdateHistory;  XVBPushHistory(Text) > 0 ƓB

Cxg
OnSetText;  R[hA܂ IAutoComplete  Text vpeBύXۂɔB

̂ق̃vpeBA\bhACxg TComboBox ƓB

̍XV͎ł͍sȂBPushHistory  UpdateHistory ōXV̂ƁB
IAutoComplete ̃Cxg͂Ȃ炵BSuggestDropedDown, OnSetText ȂǂŐ@B
VK_RETURN, VK_ESCAPE gV[gJbg{^ƁA炪D悳邽߁A
TWFXgN[YAbvȂBtH[JX̕ύXȂǂŖIɃN[Y邱ƁB

  @\ǉR{{bNX *)

unit AfCombo;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Classes, Vcl.Controls, Winapi.ActiveX,
  Vcl.StdCtrls, Vcl.ComCtrls, Winapi.ShlObj;

type
  TStringsEnumerator = class(TInterfacedObject, IEnumString)
  private
    FItems: TStrings;
    FCurrentIndex: Integer;
    type
      TPtrArray = array[0..0] of Pointer;
  protected
    //IEnumString
    function Next(celt: Longint; out elt; pceltFetched: PLongint): HResult; stdcall;
    function Skip(celt: Longint): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Clone(out enm: IEnumString): HResult; stdcall;
  public
    constructor Create(AItems: TStrings);
  end;

  TAutoCompleteSource = (
    acsHistory, //[U[ URL B
    acsISF,     //VFl[Xy[X̃ACeB
    acsMRU,     //[U[̍ŋߎgpt@CB
    acsStrings  //BItems.Strings ƓB
  );

  TACListOption = ({acloNone,} acloCurrentDir, acloMycomputer, acloDesktop, acloFavorites, acloFileSysOnly,
    acloFileSysDirs,      //Internet Explorer 6 or greater
    acloVirtualNamespace  //Windows Internet Explorer 7 or greater
  );
  TACListOptions = set of TACListOption;

  TCustomComboBoxAf = class(TCustomComboBox)
  private
    { Private 錾 }
    FAutoCompleteOptions: TAutoCompleteOptions;
    FAutoCompleteSource: TAutoCompleteSource;
    FAutoCompleteListOptions: TACListOptions;
    FWorkingDirectory: string;
    FTextTip: Boolean;
    FMaxCount: Integer;
    FDropDownWidth: Integer;
    FOnSetText: TNotifyEvent;
    procedure CMHintShow(var Msg: TCMHintShow); message CM_HINTSHOW;
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
    function GetAutoComplete: Boolean;
    procedure SetAutoComplete(Value: Boolean);
    function GetAutoDropDown: Boolean;
    procedure SetAutoDropDown(Value: Boolean);
    procedure UpdateAutoComplete;
    procedure SetAutoCompleteOptions(Value: TAutoCompleteOptions);
    procedure SetAutoCompleteSource(Value: TAutoCompleteSource);
    procedure SetAutoCompleteListOptions(Value: TACListOptions);
    function GetCurrentDir: string;
    procedure SetCurrentDir(Value: string);
    function GetSuggestDropedDown: Boolean;
    procedure SetMaxCount(Value: Integer);
    function HistoryCount: Integer;
  protected
    { Protected 錾 }
    FAutoCompleteIntf: IAutoComplete;
    FStrEnum: IEnumString;
    procedure CreateWnd; override;
    procedure DestroyWnd; override;
    procedure EditWndProc(var Message: TMessage); override;
    procedure DropDown; override;
    procedure CloseUp; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function PushHistory(Value: string): Integer;
    function UpdateHistory: Boolean;
    property AutoComplete: Boolean read GetAutoComplete write SetAutoComplete default True;
    property AutoDropDown: Boolean read GetAutoDropDown write SetAutoDropDown default False;
    property AutoCompleteOptions: TAutoCompleteOptions read FAutoCompleteOptions write SetAutoCompleteOptions default [];
    property AutoCompleteSource: TAutoCompleteSource read FAutoCompleteSource write SetAutoCompleteSource default acsStrings;
    property AutoCompleteListOptions: TACListOptions read FAutoCompleteListOptions write SetAutoCompleteListOptions default [];
    property WorkingDirectory: string read GetCurrentDir write SetCurrentDir;
    property SuggestDropedDown: Boolean read GetSuggestDropedDown;
    property MaxCount: Integer read FMaxCount write SetMaxCount default 8;
    property DropDownWidth: Integer read FDropDownWidth write FDropDownWidth default 0;
    property TextTip: Boolean read FTextTip write FTextTip default False;
    property OnSetText: TNotifyEvent read FOnSetText write FOnSetText;
  published
    { Published 錾 }
  end;

  TComboBoxAf = class(TCustomComboBoxAf)
  published
    { Published 錾 }
    property AutoCompleteOptions;
    property AutoCompleteSource;
    property AutoCompleteListOptions;
    property WorkingDirectory;
    property MaxCount;
    property DropDownWidth;
    property TextTip;
    property OnSetText;
    //TCustomComboBox p
    property Align;
    property AutoComplete default True;
    property AutoCompleteDelay default 500;
    property AutoDropDown default False;
    property AutoCloseUp default False;
    property BevelEdges;
    property BevelInner;
    property BevelKind default bkNone;
    property BevelOuter;
    property Style; {Must be published before Items}
    property Anchors;
    property BiDiMode;
    property CharCase;
    property Color;
    property Constraints;
    property Ctl3D;
    property DoubleBuffered;
    property DragCursor;
    property DragKind;
    property DragMode;
    property DropDownCount;
    property Enabled;
    property Font;
    property ImeMode;
    property ImeName;
    property ItemHeight;
    property ItemIndex default -1;
    property MaxLength;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentDoubleBuffered;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Sorted;
    property TabOrder;
    property TabStop;
    property Text;
    property TextHint;
    property Touch;
    property Visible;
    property StyleElements;
    property OnChange;
    property OnClick;
    property OnCloseUp;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDrawItem;
    property OnDropDown;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnGesture;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMeasureItem;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnSelect;
    property OnStartDock;
    property OnStartDrag;
    property Items; { Must be published after OnMeasureItem }
  end;

procedure Register;

implementation

uses
  System.Win.ComObj, System.Math;

{ TStringsEnumerator }

constructor TStringsEnumerator.Create(AItems: TStrings);
begin
  inherited Create;

  FItems := AItems;
end;

function TStringsEnumerator.Next(celt: Longint; out elt; pceltFetched: PLongint): HResult;
var
  I: Integer;
  W: WideString;
  Size: Integer;
begin
  I := 0;
  while (I < celt) and (FCurrentIndex < FItems.Count) do
  begin
    W := FItems.Strings[FCurrentIndex];
    Size := Length(W) * SizeOf(WideChar);
    TPtrArray(elt)[I] := CoTaskMemAlloc(Size + SizeOf(WideChar));
    FillChar(TPtrArray(elt)[I]^, Size + SizeOf(WideChar), 0);
    CopyMemory(TPtrArray(elt)[I], PWideString(W), Size);
    Inc(I);
    Inc(FCurrentIndex);
  end;
  if pceltFetched <> nil then
    pceltFetched^ := I;
  if I = celt then
    Result := S_OK
  else
    Result := S_FALSE;
end;

function TStringsEnumerator.Skip(celt: Longint): HResult;
begin
  FCurrentIndex := FCurrentIndex + celt;
  if FCurrentIndex < FItems.Count then
    Result := S_OK
  else
  begin
    FCurrentIndex := 0;
    Result := S_FALSE;
  end;
end;

function TStringsEnumerator.Reset: HResult;
begin
  FCurrentIndex := 0;
  Result := S_OK;
end;

function TStringsEnumerator.Clone(out enm: IEnumString): HResult;
var
  NewEnum: TStringsEnumerator;
begin
  NewEnum := TStringsEnumerator.Create(FItems);
  enm := NewEnum;
  NewEnum.FCurrentIndex := FCurrentIndex;
  Result := S_OK;
end;

{ TCustomComboBoxAf }

constructor TCustomComboBoxAf.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FAutoCompleteIntf := nil;
  FStrEnum := nil;
  FAutoCompleteOptions := [];
  FAutoCompleteSource := acsStrings;
  FAutoCompleteListOptions := [];
  FWorkingDirectory := '';
  FMaxCount := 8;
  FDropDownWidth := 0;
  FTextTip := False;
end;

procedure TCustomComboBoxAf.CreateWnd;
begin
  inherited CreateWnd;

  CoCreateInstance(CLSID_AutoComplete, nil, CLSCTX_INPROC_SERVER, IAutoComplete, FAutoCompleteIntf);
  if Assigned(FAutoCompleteIntf) then
  begin
    case FAutoCompleteSource of
      acsHistory: FStrEnum := CreateComObject(CLSID_ACLHistory) as IEnumString;
      acsISF: FStrEnum := CreateComObject(CLSID_ACListISF) as IEnumString;
      acsMRU: FStrEnum := CreateComObject(CLSID_ACLMRU) as IEnumString;
      acsStrings: FStrEnum := TStringsEnumerator.Create(Items);
    end;
    if Succeeded(FAutoCompleteIntf.Init(FEditHandle, FStrEnum, nil, nil)) then
      UpdateAutoComplete;
  end;
end;

procedure TCustomComboBoxAf.DestroyWnd;
begin
  if Assigned(FAutoCompleteIntf) then
  begin
    FAutoCompleteIntf.Enable(False);
    FAutoCompleteIntf := nil;
    FStrEnum := nil;
  end;

  inherited DestroyWnd;
end;

procedure TCustomComboBoxAf.EditWndProc(var Message: TMessage);
begin
  inherited EditWndProc(Message);

  case Message.Msg of
    WM_SETTEXT:
    begin
      if Assigned(FOnSetText) then
        FOnSetText(Self);
    end;
  end;
end;

procedure TCustomComboBoxAf.DropDown;
var
  i, ListWidth: Integer;
begin
  //hbv_EXg\ĂԂ IAutoComplete ~Ȃƃ^[L[ȂB
  if HandleAllocated and Assigned(FAutoCompleteIntf) then
    FAutoCompleteIntf.Enable(False);

  while Items.Count > HistoryCount do
    Items.Delete(Items.Count - 1);

  if FDropDownWidth <= 0 then
  begin
    ListWidth := Width;
    if FDropDownWidth < 0 then
      for i := 0 to Items.Count - 1 do
        ListWidth := Max(ListWidth, Canvas.TextWidth(Items.Strings[i]) + 24);
  end
  else
    ListWidth := FDropDownWidth;
  Perform(CB_SETDROPPEDWIDTH, ListWidth, 0);

  inherited DropDown;
end;

procedure TCustomComboBoxAf.CloseUp;
begin
  inherited CloseUp;

  UpdateAutoComplete;
end;

procedure TCustomComboBoxAf.CMHintShow(var Msg: TCMHintShow);
begin
  if TextTip then
  begin
    if (ClientWidth - Height) < Canvas.TextWidth(Text) then
      Msg.HintInfo^.HintStr := Text
    else
      Msg.HintInfo^.HintStr := '';
    Msg.Result := 0;
  end
  else
    inherited;
end;

procedure TCustomComboBoxAf.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
  inherited;
  if SuggestDropedDown then Message.Result := Message.Result or DLGC_WANTALLKEYS;
end;

destructor TCustomComboBoxAf.Destroy;
begin

  inherited Destroy;
end;

function TCustomComboBoxAf.GetAutoComplete: Boolean;
begin
  Result := inherited AutoComplete;
end;

procedure TCustomComboBoxAf.SetAutoComplete(Value: Boolean);
begin
  inherited AutoComplete := Value;

  if AutoComplete then
  begin
    Exclude(FAutoCompleteOptions, acoAutoSuggest);
    Exclude(FAutoCompleteOptions, acoAutoAppend);
  end;
end;

function TCustomComboBoxAf.GetAutoDropDown: Boolean;
begin
  Result := inherited AutoDropDown;
end;

procedure TCustomComboBoxAf.SetAutoDropDown(Value: Boolean);
begin
  inherited AutoDropDown := Value;

  if AutoDropDown then
    Exclude(FAutoCompleteOptions, acoAutoSuggest);
end;

procedure TCustomComboBoxAf.UpdateAutoComplete;
var
  Auto2: IAutoComplete2;
  ActualOptions: DWORD;
  List2: IACList2;
  Directory: ICurrentWorkingDirectory;
begin
  if HandleAllocated and Assigned(FAutoCompleteIntf) then
  begin
    if Supports(FAutoCompleteIntf, IAutoComplete2, Auto2) then
    begin
      ActualOptions := ACO_NONE;
      if acoAutoSuggest in FAutoCompleteOptions then
        ActualOptions := ActualOptions or ACO_AUTOSUGGEST;
      if acoAutoAppend in FAutoCompleteOptions then
        ActualOptions := ActualOptions or ACO_AUTOAPPEND;
      if acoSearch in FAutoCompleteOptions then
        ActualOptions := ActualOptions or ACO_SEARCH;
      if acoFilterPrefixes in FAutoCompleteOptions then
        ActualOptions := ActualOptions or ACO_FILTERPREFIXES;
      if acoUseTab in FAutoCompleteOptions then
        ActualOptions := ActualOptions or ACO_USETAB;
      if acoUpDownKeyDropsList in FAutoCompleteOptions then
        ActualOptions := ActualOptions or ACO_UPDOWNKEYDROPSLIST;
      if acoRtlReading in FAutoCompleteOptions then
        ActualOptions := ActualOptions or ACO_RTLREADING;

      Auto2.SetOptions(ActualOptions);
      FAutoCompleteIntf.Enable(ActualOptions <> ACO_NONE);
    end
    else
      FAutoCompleteIntf.Enable(acoAutoSuggest in FAutoCompleteOptions);

    if FAutoCompleteSource = acsISF then
    begin
      if Supports(FStrEnum, IACList2, List2) then
      begin
        ActualOptions := ACLO_NONE;
        if acloCurrentDir in FAutoCompleteListOptions then
          ActualOptions := ActualOptions or ACLO_CURRENTDIR;
        if acloMycomputer in FAutoCompleteListOptions then
          ActualOptions := ActualOptions or ACLO_MYCOMPUTER;
        if acloDesktop in FAutoCompleteListOptions then
          ActualOptions := ActualOptions or ACLO_DESKTOP;
        if acloFavorites in FAutoCompleteListOptions then
          ActualOptions := ActualOptions or ACLO_FAVORITES;
        if acloFileSysOnly in FAutoCompleteListOptions then
          ActualOptions := ActualOptions or ACLO_FILESYSONLY;
        if acloFileSysDirs in FAutoCompleteListOptions then
          ActualOptions := ActualOptions or ACLO_FILESYSDIRS;
        if acloVirtualNamespace in FAutoCompleteListOptions then
          ActualOptions := ActualOptions or ACLO_VIRTUALNAMESPACE;

        List2.SetOptions(ActualOptions);
        if Supports(List2, ICurrentWorkingDirectory, Directory) then
          Directory.SetDirectory(PChar(FWorkingDirectory));
      end;
    end;
  end;
end;

procedure TCustomComboBoxAf.SetAutoCompleteOptions(Value: TAutoCompleteOptions);
begin
  if Value <> FAutoCompleteOptions then
  begin
    FAutoCompleteOptions := Value;
    if acoAutoSuggest in FAutoCompleteOptions then
    begin
      AutoComplete := False;
      AutoDropDown := False;
    end;
    if acoAutoAppend in FAutoCompleteOptions then
      AutoComplete := False;
    UpdateAutoComplete;
  end;
end;

procedure TCustomComboBoxAf.SetAutoCompleteSource(Value: TAutoCompleteSource);
begin
  if Value <> FAutoCompleteSource then
  begin
    FAutoCompleteSource := Value;
    RecreateWnd;
  end;
end;

procedure TCustomComboBoxAf.SetAutoCompleteListOptions(Value: TACListOptions);
begin
  if Value <> FAutoCompleteListOptions then
  begin
    FAutoCompleteListOptions := Value;
    UpdateAutoComplete;
  end;
end;

function TCustomComboBoxAf.GetCurrentDir: string;
{var
  List2: IACList2;
  Directory: ICurrentWorkingDirectory;
  Path: PChar;}
begin
  Result := FWorkingDirectory;
  //ȂAResult j󂳂ăANZXᔽN̂łƂ肠RgAEgB
  {if Assigned(FStrEnum) and Supports(FStrEnum, IACList2, List2) then
    if Supports(List2, ICurrentWorkingDirectory, Directory) then
    begin
      if Succeeded(Directory.GetDirectory(Path, 0)) then
        Result := Path;
    end;}
end;

procedure TCustomComboBoxAf.SetCurrentDir(Value: string);
begin
  if Value <> FWorkingDirectory then
  begin
    FWorkingDirectory := Value;
    UpdateAutoComplete;
  end;
end;

function TCustomComboBoxAf.GetSuggestDropedDown: Boolean;
var
  AutoDropDown: IAutoCompleteDropDown;
  Flags: Cardinal;
  p: PChar;
begin
  Result := False;
  if Supports(FAutoCompleteIntf, IAutoCompleteDropDown, AutoDropDown) then
  begin
    AutoDropDown.GetDropDownStatus(Flags, p);
    try
      Result := Flags = ACDD_VISIBLE;
    finally
      if Assigned(p) then
        CoTaskMemFree(p);
    end;
  end;
end;

procedure TCustomComboBoxAf.SetMaxCount(Value: Integer);
begin
  if FMaxCount <> Value then
  begin
    FMaxCount := Value;
    while Items.Count > HistoryCount do
      Items.Delete(Items.Count - 1);
  end;
end;

function TCustomComboBoxAf.HistoryCount: Integer;
begin
  if FMaxCount > 0 then
    Result := FMaxCount
  else
    Result := Items.Count;
end;

function TCustomComboBoxAf.PushHistory(Value: string): Integer;
begin
  Result := Items.IndexOf(Value);
  if Result >= 0 then
    Items.Move(Result, 0)
  else
  begin
    Items.Insert(0, Value);
    if Items.Count > HistoryCount then
      Items.Delete(Items.Count - 1);
  end;
  Text := Value;
  ItemIndex := 0;
end;

function TCustomComboBoxAf.UpdateHistory: Boolean;
begin
  Result := PushHistory(Text) <> 0;
end;

procedure Register;
begin
  RegisterComponents('Samples', [TComboBoxAf]);
end;

end.
