(* TRegData

Ver, 1.00 2011/06/22 ^B
Ver, 1.01 2012/03/05 DeletePath, EraseValues ǉB
Ver, 1.02 2017/04/06 Read**Def ̎dlύXB
Ver, 1.03 2018/10/07 Read**Def ̎dlɖ߂BEraseValues  ClearValues ɉB

TRegistryg

\bh
ReadBoolDef	f[^l݂Ȃꍇ Default lԂ ReadBool
ReadIntDef	f[^l݂Ȃꍇ Default lԂ ReadInteger
ReadStrDef	f[^l݂Ȃꍇ Default lԂ ReadString
DeletePath  w肳ꂽWXgpX폜B
ClearValues ݂̃L[Ɋ֘Atꂽf[^lׂč폜B

̂ق̃vpeBA\bhACxg TRegistry ƓB
ɂKvɂȂ珇B

  g TRegistry *)

unit RegData;

interface

uses
  System.SysUtils, System.Classes, Winapi.Windows, System.Win.Registry;

type
  TRegData = class(TRegistry)
  public
  { Public 錾 }
    function ReadBoolDef(const Name: string; Default: Boolean): Boolean;
    function ReadIntDef(const Name: string; Default: Integer): Integer;
    function ReadStrDef(const Name: string; Default: string): string;
    procedure DeletePath(Path: string);
    procedure ClearValues;
  end;


implementation

function TRegData.ReadBoolDef(const Name: string; Default: Boolean): Boolean;
begin
  if ValueExists(Name) then
    Result := ReadBool(Name)
  else
    Result := Default;
end;

function TRegData.ReadIntDef(const Name: string; Default: Integer): Integer;
begin
  if ValueExists(Name) then
    Result := ReadInteger(Name)
  else
    Result := Default;
end;

function TRegData.ReadStrDef(const Name: string; Default: string): string;
begin
  if ValueExists(Name) then
    Result := ReadString(Name)
  else
    Result := Default;
end;

procedure TRegData.DeletePath(Path: string);
var
  Parent, Current: string;
  Used: Boolean;
begin
  Parent := CurrentPath;
  while Path <> '' do
  begin
    Current := ExtractFileName(Path);
    Path := ExtractFileDir(Path);
    Used := True;
    if OpenKey(Path, False) then
    begin
      DeleteKey(Current);
      Used := HasSubKeys;
      CloseKey;
      OpenKey(Parent, False);
    end;
    if Used then Break;
  end;
end;

procedure TRegData.ClearValues;
var
  Names: TStrings;
  i: Integer;
begin
  Names := TStringList.Create;
  try
    GetValueNames(Names);
    for i := 0 to Names.Count - 1 do
      DeleteValue(Names.Strings[i]);
  finally
    Names.Free;
  end;
end;

end.

